From 37168d1560eb62f657afdd4653c7c1a92e1fb8a4 Mon Sep 17 00:00:00 2001
From: Carl Huang <cjhuang@codeaurora.org>
Date: Mon, 16 Mar 2020 10:48:40 +0800
Subject: [PATCH 075/124] ath11k: hook mhi suspend and resume

MHI suspend and resume isn't hooked in ath11k yet, so hook these
functions. Host also exposes functions for hif layer to call.

Tested-on: QCA6390 WLAN.HST.1.0.1-01230-QCAHSTSWPLZ_V2_TO_X86-1

Change-Id: I9e8d9d00c1f4fab8735a24c132cfff3846f447e9
Signed-off-by: Carl Huang <cjhuang@codeaurora.org>
---
 drivers/net/wireless/ath/ath11k/mhi.c | 17 +++++++++++++++++
 drivers/net/wireless/ath/ath11k/mhi.h |  3 +++
 2 files changed, 20 insertions(+)

diff --git a/drivers/net/wireless/ath/ath11k/mhi.c b/drivers/net/wireless/ath/ath11k/mhi.c
index aac3a9a..c60898d 100644
--- a/drivers/net/wireless/ath/ath11k/mhi.c
+++ b/drivers/net/wireless/ath/ath11k/mhi.c
@@ -362,8 +362,10 @@ static int ath11k_pci_set_mhi_state(struct ath11k_pci *ab_pci,
 		ret = 0;
 		break;
 	case ATH11K_MHI_SUSPEND:
+		ret = mhi_pm_suspend(ab_pci->mhi_ctrl);
 		break;
 	case ATH11K_MHI_RESUME:
+		ret = mhi_pm_resume(ab_pci->mhi_ctrl);
 		break;
 	case ATH11K_MHI_TRIGGER_RDDM:
 		ret = mhi_force_rddm_mode(ab_pci->mhi_ctrl);
@@ -413,3 +415,18 @@ void ath11k_pci_stop_mhi(struct ath11k_pci *ab_pci)
 	ath11k_pci_set_mhi_state(ab_pci, ATH11K_MHI_DEINIT);
 }
 
+void ath11k_pci_suspend_mhi(struct ath11k_pci *ab_pci)
+{
+	ath11k_pci_set_mhi_state(ab_pci, ATH11K_MHI_SUSPEND);
+}
+
+void ath11k_pci_resume_mhi(struct ath11k_pci *ab_pci)
+{
+	ath11k_pci_set_mhi_state(ab_pci, ATH11K_MHI_RESUME);
+}
+
+void ath11k_pci_force_mhi_rddm(struct ath11k_pci *ab_pci)
+{
+	ath11k_pci_set_mhi_state(ab_pci, ATH11K_MHI_TRIGGER_RDDM);
+}
+
diff --git a/drivers/net/wireless/ath/ath11k/mhi.h b/drivers/net/wireless/ath/ath11k/mhi.h
index 355de5a..b9cc309 100644
--- a/drivers/net/wireless/ath/ath11k/mhi.h
+++ b/drivers/net/wireless/ath/ath11k/mhi.h
@@ -25,4 +25,7 @@ int ath11k_pci_start_mhi(struct ath11k_pci *ar_pci);
 void ath11k_pci_stop_mhi(struct ath11k_pci *ar_pci);
 int ath11k_pci_register_mhi(struct ath11k_pci *ar_pci);
 void ath11k_pci_unregister_mhi(struct ath11k_pci *ar_pci);
+void ath11k_pci_suspend_mhi(struct ath11k_pci *ar_pci);
+void ath11k_pci_resume_mhi(struct ath11k_pci *ar_pci);
+void ath11k_pci_force_mhi_rddm(struct ath11k_pci *ar_pci);
 #endif
-- 
2.7.4

